package cn.ibizlab.businesscentral.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.base.domain.Audit;
import cn.ibizlab.businesscentral.core.base.filter.AuditSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Audit] 服务对象接口
 */
public interface IAuditService extends IService<Audit>{

    boolean create(Audit et) ;
    void createBatch(List<Audit> list) ;
    Audit getDraft(Audit et) ;
    Audit get(String key) ;
    boolean update(Audit et) ;
    void updateBatch(List<Audit> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean save(Audit et) ;
    void saveBatch(List<Audit> list) ;
    boolean checkKey(Audit et) ;
    Page<Audit> searchDefault(AuditSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Audit> getAuditByIds(List<String> ids) ;
    List<Audit> getAuditByEntities(List<Audit> entities) ;

}


